// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/async/lib/usc_tx_clk_src.c $
// $Rev: 31500 $
// $Date: 2014-12-09 18:30:36 -0600 (Tue, 09 Dec 2014) $

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	char		buf[128];
	int			errs	= 0;
	const char*	ptr;

	gsc_label("USC Tx Clock Source");

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "This service is not supported by this board.";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_DISABLE:

			ptr	= "Disable";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_RXC_PIN:

			ptr	= "RxC Pin";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_TXC_PIN:

			ptr	= "TxC Pin";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_DPLL:

			ptr	= "DPLL";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_BRG0:

			ptr	= "BRG0";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_BRG1:

			ptr	= "BRG1";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_CTR0:

			ptr	= "CTR0";
			break;

		case SIO4_ASYNC_USC_TX_CLK_SRC_CTR1:

			ptr	= "CTR1";
			break;
	}

	printf("%s\n", ptr);
	return(errs);
}



//*****************************************************************************
void sio4_async_t_usc_tx_clk_src(
	int					fd,
	s32*				arg,
	sio4_async_action_t	action,
	const char**		err)
{
	#define		ERROR	  "async->usc.tx.clk_src"
	int			errs	= 0;
	const char*	sts		= NULL;
	s32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_ASYNC_ACTION_GET:

				arg[0]	= -1;
				errs	= sio4_usc_tx_clk_src(fd, -1, 0, arg[0], arg);
				break;

		case SIO4_ASYNC_ACTION_INIT:

				// This hard coded initialization value is modified later as
				// needed for Tx baud rate configuration.
				arg[0]	= SIO4_ASYNC_USC_TX_CLK_SRC_TXC_PIN;
				break;

		case SIO4_ASYNC_ACTION_SET:

				tmp		= arg[0];
				errs	= sio4_usc_tx_clk_src(fd, -1, 0, tmp, NULL);
				break;

		case SIO4_ASYNC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_ASYNC_ACTION_VERIFY:

				switch (arg[0])
				{
					default:				errs	= 1;	break;
					case -1:
					case SIO4_ASYNC_USC_TX_CLK_SRC_DISABLE:
					case SIO4_ASYNC_USC_TX_CLK_SRC_RXC_PIN:
					case SIO4_ASYNC_USC_TX_CLK_SRC_TXC_PIN:
					case SIO4_ASYNC_USC_TX_CLK_SRC_DPLL:
					case SIO4_ASYNC_USC_TX_CLK_SRC_BRG0:
					case SIO4_ASYNC_USC_TX_CLK_SRC_BRG1:
					case SIO4_ASYNC_USC_TX_CLK_SRC_CTR0:
					case SIO4_ASYNC_USC_TX_CLK_SRC_CTR1:	break;
				}

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


